/* WebJsonClient.c generated by valac 0.56.14, the Vala compiler
 * generated from WebJsonClient.vala, do not modify */

/*/ For fetch json from url*/

#include <glib-object.h>
#include <glib.h>
#include <json-glib/json-glib.h>
#include <stdlib.h>
#include <string.h>
#include <libsoup/soup.h>
#include <glib/gi18n-lib.h>

#define WEB_JSON_CLIENT_NO_CONNECTION 2
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_WEB_JSON_CLIENT (web_json_client_get_type ())
#define WEB_JSON_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WEB_JSON_CLIENT, WebJsonClient))
#define WEB_JSON_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WEB_JSON_CLIENT, WebJsonClientClass))
#define IS_WEB_JSON_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WEB_JSON_CLIENT))
#define IS_WEB_JSON_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WEB_JSON_CLIENT))
#define WEB_JSON_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WEB_JSON_CLIENT, WebJsonClientClass))

typedef struct _WebJsonClient WebJsonClient;
typedef struct _WebJsonClientClass WebJsonClientClass;
typedef struct _WebJsonClientPrivate WebJsonClientPrivate;
enum  {
	WEB_JSON_CLIENT_0_PROPERTY,
	WEB_JSON_CLIENT_NUM_PROPERTIES
};
static GParamSpec* web_json_client_properties[WEB_JSON_CLIENT_NUM_PROPERTIES];

#define TYPE_TRANSLATOR_ERROR (translator_error_get_type ())
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _WebJsonClient {
	GObject parent_instance;
	WebJsonClientPrivate * priv;
};

struct _WebJsonClientClass {
	GObjectClass parent_class;
};

typedef enum  {
	TRANSLATOR_ERROR_NoConnection
} TranslatorError;
#define TRANSLATOR_ERROR translator_error_quark ()

static gpointer web_json_client_parent_class = NULL;
static JsonParser* web_json_client__parser;
static JsonParser* web_json_client__parser = NULL;
VALA_EXTERN gint global_settings_SERVER_RESPOND_TIMEOUT;

VALA_EXTERN GType web_json_client_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WebJsonClient, g_object_unref)
VALA_EXTERN GQuark translator_error_quark (void);
VALA_EXTERN GType translator_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN JsonObject* web_json_client_Get (const gchar* request,
                                 GError** error);
VALA_EXTERN SoupURI* global_settings_getProxyUri (void);
static void _vala_SoupURI_free (SoupURI* self);
static JsonParser* web_json_client_get_parser (void);
VALA_EXTERN WebJsonClient* web_json_client_new (void);
VALA_EXTERN WebJsonClient* web_json_client_construct (GType object_type);
static void web_json_client_finalize (GObject * obj);
static GType web_json_client_get_type_once (void);
static void _vala_web_json_client_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);

static void
_vala_SoupURI_free (SoupURI* self)
{
	g_boxed_free (soup_uri_get_type (), self);
}

static gpointer
_json_object_ref0 (gpointer self)
{
	return self ? json_object_ref (self) : NULL;
}

JsonObject*
web_json_client_Get (const gchar* request,
                     GError** error)
{
	SoupSession* session = NULL;
	SoupSession* _tmp0_;
	SoupSession* _tmp1_;
	SoupSession* _tmp2_;
	SoupURI* _tmp3_;
	SoupURI* _tmp4_;
	SoupURI* url = NULL;
	SoupURI* _tmp5_;
	SoupMessage* message = NULL;
	SoupURI* _tmp6_;
	SoupMessage* _tmp7_;
	guint status = 0U;
	SoupSession* _tmp8_;
	SoupMessage* _tmp9_;
	JsonParser* _tmp19_;
	JsonParser* _tmp20_;
	JsonNode* _tmp21_;
	JsonObject* _tmp22_;
	JsonObject* _tmp23_;
	GError* _inner_error0_ = NULL;
	JsonObject* result;
	g_return_val_if_fail (request != NULL, NULL);
	_tmp0_ = soup_session_new ();
	session = _tmp0_;
	_tmp1_ = session;
	g_object_set (_tmp1_, "timeout", (guint) global_settings_SERVER_RESPOND_TIMEOUT, NULL);
	_tmp2_ = session;
	_tmp3_ = global_settings_getProxyUri ();
	_tmp4_ = _tmp3_;
	g_object_set (_tmp2_, "proxy-uri", _tmp4_, NULL);
	__vala_SoupURI_free0 (_tmp4_);
	_tmp5_ = soup_uri_new (request);
	url = _tmp5_;
	_tmp6_ = url;
	_tmp7_ = soup_message_new_from_uri ("GET", _tmp6_);
	message = _tmp7_;
	_tmp8_ = session;
	_tmp9_ = message;
	status = soup_session_send_message (_tmp8_, _tmp9_);
	if (status == ((guint) WEB_JSON_CLIENT_NO_CONNECTION)) {
		GError* _tmp10_;
		_tmp10_ = g_error_new_literal (TRANSLATOR_ERROR, TRANSLATOR_ERROR_NoConnection, _ ("No connection to server"));
		_inner_error0_ = _tmp10_;
		if (_inner_error0_->domain == TRANSLATOR_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (message);
			__vala_SoupURI_free0 (url);
			_g_object_unref0 (session);
			return NULL;
		} else {
			_g_object_unref0 (message);
			__vala_SoupURI_free0 (url);
			_g_object_unref0 (session);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	{
		gchar* mess = NULL;
		SoupMessage* _tmp11_;
		SoupMessageBody* _tmp12_;
		guint8* _tmp13_;
		gint _tmp13__length1;
		gchar* _tmp14_;
		JsonParser* _tmp15_;
		JsonParser* _tmp16_;
		_tmp11_ = message;
		_tmp12_ = _tmp11_->response_body;
		_tmp13_ = _tmp12_->data;
		_tmp13__length1 = _tmp12_->length;
		_tmp14_ = g_strdup ((const gchar*) _tmp13_);
		mess = _tmp14_;
		_tmp15_ = web_json_client_get_parser ();
		_tmp16_ = _tmp15_;
		json_parser_load_from_data (_tmp16_, mess, (gssize) -1, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (mess);
			goto __catch0_g_error;
		}
		_g_free0 (mess);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
		_error_ = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp17_ = _error_;
		_tmp18_ = _tmp17_->message;
		g_warning ("WebJsonClient.vala:33: %s", _tmp18_);
		_g_error_free0 (_error_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == TRANSLATOR_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_g_object_unref0 (message);
			__vala_SoupURI_free0 (url);
			_g_object_unref0 (session);
			return NULL;
		} else {
			_g_object_unref0 (message);
			__vala_SoupURI_free0 (url);
			_g_object_unref0 (session);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp19_ = web_json_client_get_parser ();
	_tmp20_ = _tmp19_;
	_tmp21_ = json_parser_get_root (_tmp20_);
	_tmp22_ = json_node_get_object (_tmp21_);
	_tmp23_ = _json_object_ref0 (_tmp22_);
	result = _tmp23_;
	_g_object_unref0 (message);
	__vala_SoupURI_free0 (url);
	_g_object_unref0 (session);
	return result;
}

WebJsonClient*
web_json_client_construct (GType object_type)
{
	WebJsonClient * self = NULL;
	self = (WebJsonClient*) g_object_new (object_type, NULL);
	return self;
}

WebJsonClient*
web_json_client_new (void)
{
	return web_json_client_construct (TYPE_WEB_JSON_CLIENT);
}

static JsonParser*
web_json_client_get_parser (void)
{
	JsonParser* result;
	JsonParser* _tmp0_;
	JsonParser* _tmp2_;
	_tmp0_ = web_json_client__parser;
	if (_tmp0_ == NULL) {
		JsonParser* _tmp1_;
		_tmp1_ = json_parser_new ();
		_g_object_unref0 (web_json_client__parser);
		web_json_client__parser = _tmp1_;
	}
	_tmp2_ = web_json_client__parser;
	result = _tmp2_;
	return result;
}

static void
web_json_client_class_init (WebJsonClientClass * klass,
                            gpointer klass_data)
{
	web_json_client_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = _vala_web_json_client_get_property;
	G_OBJECT_CLASS (klass)->finalize = web_json_client_finalize;
}

static void
web_json_client_instance_init (WebJsonClient * self,
                               gpointer klass)
{
}

static void
web_json_client_finalize (GObject * obj)
{
	WebJsonClient * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WEB_JSON_CLIENT, WebJsonClient);
	G_OBJECT_CLASS (web_json_client_parent_class)->finalize (obj);
}

static GType
web_json_client_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WebJsonClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) web_json_client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WebJsonClient), 0, (GInstanceInitFunc) web_json_client_instance_init, NULL };
	GType web_json_client_type_id;
	web_json_client_type_id = g_type_register_static (G_TYPE_OBJECT, "WebJsonClient", &g_define_type_info, 0);
	return web_json_client_type_id;
}

GType
web_json_client_get_type (void)
{
	static volatile gsize web_json_client_type_id__once = 0;
	if (g_once_init_enter (&web_json_client_type_id__once)) {
		GType web_json_client_type_id;
		web_json_client_type_id = web_json_client_get_type_once ();
		g_once_init_leave (&web_json_client_type_id__once, web_json_client_type_id);
	}
	return web_json_client_type_id__once;
}

static void
_vala_web_json_client_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	WebJsonClient * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WEB_JSON_CLIENT, WebJsonClient);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

